import spotipy
import random
import os
import threading
from spotipy.oauth2 import SpotifyOAuth

def shufflePart(rangeLen, threadNum):
    startRange = rangeLen * threadNum
    print("thread " + str(threadNum) + " starting, startRange = " +str(startRange) + ", endRange = " + str(rangeLen + startRange))
    for i in range(startRange, rangeLen+startRange):
        print("thread " + str(threadNum+1) + ", shuffled: " + str(i-startRange) + "/" + str(rangeLen) + " (" + str(((i-startRange)*100)//rangeLen) + "%)")
        spotify.playlist_reorder_items(toShuffle, i, random.randint(0, playlistLength))

if __name__ =="__main__":

    # SET ENVIRONMENT VARIABLES HERE
    os.environ["SPOTIPY_CLIENT_ID"] = "YOUR CLIENT ID HERE"
    os.environ["SPOTIPY_CLIENT_SECRET"] = "YOUR CLIENT SECRET HERE"
    
    os.environ["SPOTIPY_REDIRECT_URI"] = "https://localhost:8888/callback"
    scope = "user-library-read, playlist-modify-public, playlist-modify-private, playlist-read-private"
    spotify = spotipy.Spotify(auth_manager=SpotifyOAuth(scope=scope))
    print("Spotify playlist shuffler v1.0 by ankledog; check the readme for more info")
    toShuffle = input("Please paste a link to the playlist you would like to shuffle: ")w
    if (toShuffle == ""):
        print("Please paste a link to a playlist")
        exit()
    playlistLength = int(input("How many songs are in this playlist? "))

    # If you would like to modify the amount of threads, change this value...
    numOfThreads = 4
    
    threadLen = playlistLength//numOfThreads
    extraLen = playlistLength%numOfThreads
    
    # ...and create additional thread definitions, starts and joins
    t1 = threading.Thread(target=shufflePart, args=(threadLen,0,))
    t2 = threading.Thread(target=shufflePart, args=(threadLen,1,))
    t3 = threading.Thread(target=shufflePart, args=(threadLen,2,))
    t4 = threading.Thread(target=shufflePart, args=(threadLen,3,))
    
    t1.start()
    t2.start()
    t3.start()
    t4.start()

    t1.join()
    t2.join()
    t3.join()
    t4.join()
    
    for i in range(playlistLength - extraLen, playlistLength):
        print("shuffling remainder: " + str(i) + "/" + str(extraLen) + " (" + str(((i)*100)//extraLen) + "%)")
        spotify.playlist_reorder_items(toShuffle, i, random.randint(0, playlistLength))

    print("shuffle complete!")
